program travel;

const
	MAXN					= 10000;   { 10000 }
	MAXM					= 100000;  { 100000 }
	INF					= 1000000; { 1000000 }
	inFile					= '';

type
	Integer					= LongInt;
	PTr					= ^TTr;
	TTr					= record
		ind, c, h, l			: Integer;
		next				: PTr;
	end;

var
	P					: Pointer;
	T					: Array [1 .. MAXN] of PTr;
	used					: Array [1 .. MAXN] of Boolean;
	d					: Array [1 .. MAXN] of Integer;
	cameWith				: Array [1 .. MAXN] of Integer;
	cameFrom				: Array [1 .. MAXN] of Integer;
	N, M, i, j				: Integer;
	f					: Text;
	printed					: Boolean;

procedure finalize;
begin
	Release(P);
end;

procedure writeOutput;
var
	curr					: Integer;
	list					: Array [1 .. MAXM] of Integer;
	listNum					: Integer;
begin
	curr := N;
	listNum := 0;
	while (curr <> 1) do begin
		listNum := listNum + 1;
		list[listNum] := cameWith[curr];
		curr := cameFrom[curr];
	end;
	writeln(d[N]);
	writeln(listNum);
	for i := listNum downto 1 do
		writeln(list[i]);
end;

procedure Init;
begin
	for i := 1 to N do begin
		T[i] := NIL;
		used[i] := False;
		d[i] := INF;
	end;
	printed := False;
end;

procedure add(var head: PTr; cInd, cCity, cHour, cLength: Integer);
var
	newEl					: PTr;
begin
	new(newEl);
	newEl^.ind := cInd;
	newEl^.c := cCity;
	newEl^.h := cHour;
	newEl^.l := cLength;
	if (head = NIL) then begin
		head := newEl;
		head^.next := NIL;
	end else begin
		newEl^.next := head;
		head := newEl;
	end;
end;

procedure readInput;
var
	a, b, c, d				: Integer;
begin
	assign(f, inFile);
	reset(f);
	readln(f, N, M);
	Init;
	for i := 1 to M do begin
		readln(f, a, b, c, d);
		add(T[a], i, b, c, d);
	end;
	close(f);	
end;

procedure Solve;
var
	cMin, cminInd				: Integer;
	el					: PTr;
	curr					: Integer;
	ce					: Integer;
	cT					: Integer;
begin
	cameFrom[1] := 0;
	used[1] := True;
	el := T[1];
	while (el <> NIL) do begin
		if (d[el^.c] > el^.h + el^.l) then begin
			d[el^.c] := el^.h + el^.l;
			cameWith[el^.c] := el^.ind;
			cameFrom[el^.c] := 1;
		end;
                el := el^.next;
	end;
	for curr := 1 to (N - 1) do begin
		cMin := INF + 1;
		for i := 1 to N do
			if (not used[i]) and (d[i] < cMin) then begin
				cMin := d[i];
				cminInd := i;
			end;
		ce := cminInd;
		if (ce = N) then begin
			printed := True;
			writeOutput;
			finalize;
			Exit;
		end;
                used[ce] := True;
		cT := cMin;
		el := T[ce];
		while (el <> NIL) do begin
			if (cT <= el^.h) and (d[el^.c] > el^.h + el^.l) then begin
				d[el^.c] := el^.h + el^.l;
				cameWith[el^.c] := el^.ind;
				cameFrom[el^.c] := ce;
			end;
                        el := el^.next;
		end;
	end;
end;

begin
	Mark(P);
	readInput;
	Solve;
	if (not printed) then begin
		writeOutput;
		finalize;
	end;
end.